xfs
[Top] [All Lists]

[PATCH] xfstests: btrfs/003: regression test for subvol delete V2

To: <linux-btrfs@xxxxxxxxxxxxxxx>, <xfs@xxxxxxxxxxx>
Subject: [PATCH] xfstests: btrfs/003: regression test for subvol delete V2
From: Josef Bacik <jbacik@xxxxxxxxxxxx>
Date: Tue, 13 Aug 2013 15:34:18 -0400
Delivered-to: xfs@xxxxxxxxxxx
Dkim-signature: v=1; a=rsa-sha256; c=relaxed/simple; d=fusionio.com; s=default; t=1376422461; bh=LV0F1taPtklavAL+r1QpobC+lpjRLuInfWBNPYZZMm0=; h=From:To:Subject:Date; b=Nqnd9PybyQDApEu4uvX5ImjAXZQ0OeooU5hmx3UNmP+zVC+1SmOb50382CAUspRUf cjPBqCR9WtagkFZj214kRQjX8xibSMW9ONLZ6XxURqWNhFdzTQ2nysly1t2xpcF9lB gC/slGoo82nVjoCmAQLKGcZbq+i19Oicjb+hTjH0=
We were allowing users to delete their default subvolume, which is problematic.
This test is a regression test to make sure we don't let that happen in the
future.  Thanks,

Signed-off-by: Josef Bacik <jbacik@xxxxxxxxxxxx>
---
V1->V2: address the comments made by Eric Sandeen.

 tests/btrfs/003     |   66 +++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/btrfs/003.out |    2 +
 tests/btrfs/group   |    1 +
 3 files changed, 69 insertions(+), 0 deletions(-)
 create mode 100755 tests/btrfs/003
 create mode 100644 tests/btrfs/003.out

diff --git a/tests/btrfs/003 b/tests/btrfs/003
new file mode 100755
index 0000000..aba883d
--- /dev/null
+++ b/tests/btrfs/003
@@ -0,0 +1,66 @@
+#! /bin/bash
+# FS QA Test No. btrfs/003
+#
+# Regression test to make sure we can't delete the default subvol
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2013 Fusion IO.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+
+status=1       # failure is the default!
+
+_cleanup()
+{
+       rm -f $tmp.*
+}
+
+trap "_cleanup ; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# real QA test starts here
+_supported_fs btrfs
+_supported_os Linux
+_require_scratch
+
+_scratch_mkfs > /dev/null 2>&1
+_scratch_mount
+
+# This will be set to subvolid 256.  If this ever changes in the future for
+# whatever reason we'll have to pull the subvolid out of the subvol list 
command
+# but since it's a newly mkfs'ed fs we should be fine with this.
+$BTRFS_UTIL_PROG sub create $SCRATCH_MNT/newvol >> $seqres.full 2>&1 \
+       || _fail "couldn't create subvol"
+subvolid=$($BTRFS_UTIL_PROG sub list $SCRATCH_MNT | grep newvol | awk '{ print 
$2 }')
+$BTRFS_UTIL_PROG sub set-default $subvolid $SCRATCH_MNT >> $seqres.full 2>&1 \
+       || _fail "couldn't set default"
+$BTRFS_UTIL_PROG sub delete $SCRATCH_MNT/newvol >> $seqres.full 2>&1
+_scratch_unmount
+_scratch_mount || _fail "mount should have succeeded"
+
+echo "Silence is golden"
+status=0 ; exit
diff --git a/tests/btrfs/003.out b/tests/btrfs/003.out
new file mode 100644
index 0000000..6895fc8
--- /dev/null
+++ b/tests/btrfs/003.out
@@ -0,0 +1,2 @@
+QA output created by 003
+Silence is golden
diff --git a/tests/btrfs/group b/tests/btrfs/group
index 5b65068..86f5a5a 100644
--- a/tests/btrfs/group
+++ b/tests/btrfs/group
@@ -5,6 +5,7 @@
 #
 001 auto quick
 002 auto quick
+003 auto quick
 254 auto quick
 264 auto
 265 auto
-- 
1.7.7.6

<Prev in Thread] Current Thread [Next in Thread>